//====================================================================
//IUS51(In User's System for uProbe51) header for serial function
//				Version 1.00
//Copyright @2006 DEEMAX Electronics, Inc.
//
//This file is maintained by DEEMAX Electronics Inc.
//Please DO NOT EDIT any code in this file.
//To change variant options, Modify "ius51Options.h" instead.
//====================================================================
#include "DataType.h"
#include "IUS51options.h"

//-----Preround setup serial of Timer  -----------------------------------------------------------------------
#ifdef ius_BR230400  //setup ius_TH1_230400
  #define ius_INACCURACY230400	ius_BR230400
#endif
#ifdef ius_BR115200  //setup ius_TH1_115200
  #define ius_INACCURACY115200	ius_BR115200
#endif
#ifdef ius_BR57600  //setup ius_TH1_57600
  #define ius_INACCURACY57600	ius_BR57600
#endif
#ifdef ius_BR38400  //setup ius_TH1_3800
  #define ius_INACCURACY38400	ius_BR38400
#endif
#ifdef ius_BR19200  //setup ius_TH1_19200
  #define ius_INACCURACY19200	ius_BR19200
#endif
#ifdef ius_BR9600  //setup ius_TH1_9600
  #define ius_INACCURACY9600	ius_BR9600
#endif
#ifdef ius_BR4800  //setup ius_TH1_4800
  #define ius_INACCURACY4800	ius_BR4800
#endif
//---------------------------------------------------------------------
#if (ius_BaudRateUseTimer == 1)
  sfr iusBaudTimer = 0x8D;
  #define iusSerialTimerTrigger(s) TR1=s
  #define TypeOfTimer	BYTE
  #define MAX_TIMER_VAL	(256UL)
#elif (ius_BaudRateUseTimer == 2)
  sfr16 iusBaudTimer = 0xCA;
  #define iusSerialTimerTrigger(s) TR2=s
  #define TypeOfTimer	WORD
  #define MAX_TIMER_VAL	(65536UL)
#else
>>>Error: Wrong ius_BaudRateUseTimer definition
#endif
#define ius_TimerEvaluate(iusSTB,b)		(MAX_TIMER_VAL-(ius_SYSTEM_CLOCK/(iusSTB*b)))
#define ius_BaudEvaluate(iusSTB,timer)	(ius_SYSTEM_CLOCK/(iusSTB*(MAX_TIMER_VAL-timer)))
//-----Round of 230400 Baud Rates -----------------------------------------------------------------------
#ifdef ius_BR230400
  #ifdef iusSTB0
    #define ius_V230400_STB0	ius_TimerEvaluate(iusSTB0,ius_BR230400)
	#if (ius_V230400_STB0<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB0, ius_V230400_STB0)-ius_BR230400)<=ius_INACCURACY230400)
        #undef ius_INACCURACY230400
        #undef ius_v230400
        #undef ius_SetupTimeBase230400
        #define ius_INACCURACY230400 (ius_BaudEvaluate(iusSTB0, ius_V230400_STB0)-ius_BR230400)
        #define ius_v230400	((TypeOfTimer)ius_V230400_STB0)
        #define ius_SetupTimeBase230400 iusSETUP_STB0
      #endif
	#endif
  #endif //iusSTB0
  #ifdef iusSTB1
    #define ius_V230400_STB1	ius_TimerEvaluate(iusSTB1,ius_BR230400)
	#if (ius_V230400_STB1<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB1, ius_V230400_STB1)-ius_BR230400)<=ius_INACCURACY230400)
        #undef ius_INACCURACY230400
        #undef ius_v230400
        #undef ius_SetupTimeBase230400
        #define ius_INACCURACY230400 (ius_BaudEvaluate(iusSTB1, ius_V230400_STB1)-ius_BR230400)
        #define ius_v230400	((TypeOfTimer)ius_V230400_STB1)
        #define ius_SetupTimeBase230400 iusSETUP_STB1
      #endif
    #endif
  #endif //iusSTB1
  #ifdef iusSTB2
    #define ius_V230400_STB2	ius_TimerEvaluate(iusSTB2,ius_BR230400)
	#if (ius_V230400_STB2<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB2, ius_V230400_STB2)-ius_BR230400)<=ius_INACCURACY230400)
        #undef ius_INACCURACY230400
        #undef ius_v230400
        #undef ius_SetupTimeBase230400
        #define ius_INACCURACY230400 (ius_BaudEvaluate(iusSTB2, ius_V230400_STB2)-ius_BR230400)
        #define ius_v230400	((TypeOfTimer)ius_V230400_STB2)
        #define ius_SetupTimeBase230400 iusSETUP_STB2
      #endif
    #endif
  #endif //iusSTB2
  #ifdef iusSTB3
    #define ius_V230400_STB3	ius_TimerEvaluate(iusSTB3,ius_BR230400)
	#if (ius_V230400_STB3<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB3, ius_V230400_STB3)-ius_BR230400)<=ius_INACCURACY230400)
        #undef ius_INACCURACY230400
        #undef ius_v230400
        #undef ius_SetupTimeBase230400
        #define ius_INACCURACY230400 (ius_BaudEvaluate(iusSTB3, ius_V230400_STB3)-ius_BR230400)
        #define ius_v230400	((TypeOfTimer)ius_V230400_STB3)
        #define ius_SetupTimeBase230400 iusSETUP_STB3
      #endif
    #endif
  #endif //iusSTB3
  #ifdef iusSTB4
    #define ius_V230400_STB4	ius_TimerEvaluate(iusSTB4,ius_BR230400)
	#if (ius_V230400_STB4<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB4, ius_V230400_STB4)-ius_BR230400)<=ius_INACCURACY230400)
        #undef ius_INACCURACY230400
        #undef ius_v230400
        #undef ius_SetupTimeBase230400
        #define ius_INACCURACY230400 (ius_BaudEvaluate(iusSTB4, ius_V230400_STB4)-ius_BR230400)
        #define ius_v230400	((TypeOfTimer)ius_V230400_STB4)
        #define ius_SetupTimeBase230400 iusSETUP_STB4
      #endif
    #endif
  #endif //iusSTB4
  #ifdef iusSTB5
    #define ius_V230400_STB5	ius_TimerEvaluate(iusSTB5,ius_BR230400)
	#if (ius_V230400_STB5<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB5, ius_V230400_STB5)-ius_BR230400)<=ius_INACCURACY230400)
        #undef ius_INACCURACY230400
        #undef ius_v230400
        #undef ius_SetupTimeBase230400
        #define ius_INACCURACY230400 (ius_BaudEvaluate(iusSTB5, ius_V230400_STB5)-ius_BR230400)
        #define ius_v230400	((TypeOfTimer)ius_V230400_STB5)
        #define ius_SetupTimeBase230400 iusSETUP_STB5
      #endif
    #endif
  #endif //iusSTB5
  #ifdef iusSTB6
    #define ius_V230400_STB6	ius_TimerEvaluate(iusSTB6,ius_BR230400)
	#if (ius_V230400_STB6<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB6, ius_V230400_STB6)-ius_BR230400)<=ius_INACCURACY230400)
        #undef ius_INACCURACY230400
        #undef ius_v230400
  	    #undef ius_SetupTimeBase230400
        #define ius_INACCURACY230400 (ius_BaudEvaluate(iusSTB6, ius_V230400_STB6)-ius_BR230400)
        #define ius_v230400	((TypeOfTimer)ius_V230400_STB6)
        #define ius_SetupTimeBase230400 iusSETUP_STB6
     #endif
   #endif
  #endif //iusSTB6
  #ifdef iusSTB7
    #define ius_V230400_STB7	ius_TimerEvaluate(iusSTB7,ius_BR230400)
	#if (ius_V230400_STB7<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB7, ius_V230400_STB7)-ius_BR230400)<=ius_INACCURACY230400)
        #undef ius_INACCURACY230400
        #undef ius_v230400
        #undef ius_SetupTimeBase230400
        #define ius_INACCURACY230400 (ius_BaudEvaluate(iusSTB7, ius_V230400_STB7)-ius_BR230400)
        #define ius_v230400	((TypeOfTimer)ius_V230400_STB7)
        #define ius_SetupTimeBase230400 iusSETUP_STB7
      #endif
    #endif
  #endif //iusSTB7
  #ifdef iusSTB8
    #define ius_V230400_STB8	ius_TimerEvaluate(iusSTB8,ius_BR230400)
	#if (ius_V230400_STB7<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB8, ius_V230400_STB8)-ius_BR230400)<=ius_INACCURACY230400)
        #undef ius_INACCURACY230400
        #undef ius_v230400
        #undef ius_SetupTimeBase230400
        #define ius_INACCURACY230400 (ius_BaudEvaluate(iusSTB8, ius_V230400_STB8)-ius_BR230400)
        #define ius_v230400	((TypeOfTimer)ius_V230400_STB8)
        #define ius_SetupTimeBase230400 iusSETUP_STB8
      #endif
    #endif
  #endif //iusSTB8
  #ifdef iusSTB9
    #define ius_V230400_STB9	ius_TimerEvaluate(iusSTB9,ius_BR230400)
	#if (ius_V230400_STB9<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB9, ius_V230400_STB9)-ius_BR230400)<=ius_INACCURACY230400)
        #undef ius_INACCURACY230400
        #undef ius_v230400
        #undef ius_SetupTimeBase230400
        #define ius_INACCURACY230400 (ius_BaudEvaluate(iusSTB9, ius_V230400_STB9)-ius_BR230400)
        #define ius_v230400	((TypeOfTimer)ius_V230400_STB9)
        #define ius_SetupTimeBase230400 iusSETUP_STB9
      #endif
    #endif
  #endif //iusSTB9
#endif //ius_BR230400

//-----Round of 115200 Baud Rates -----------------------------------------------------------------------
#ifdef ius_BR115200
  #ifdef iusSTB0
    #define ius_V115200_STB0	ius_TimerEvaluate(iusSTB0,ius_BR115200)
	#if (ius_V115200_STB0<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB0, ius_V115200_STB0)-ius_BR115200)<=ius_INACCURACY115200)
        #undef ius_INACCURACY115200
        #undef ius_v115200
        #undef ius_SetupTimeBase115200
        #define ius_INACCURACY115200 (ius_BaudEvaluate(iusSTB0, ius_V115200_STB0)-ius_BR115200)
        #define ius_v115200	((TypeOfTimer)ius_V115200_STB0)
        #define ius_SetupTimeBase115200 iusSETUP_STB0
      #endif
	#endif
  #endif //iusSTB0
  #ifdef iusSTB1
    #define ius_V115200_STB1	ius_TimerEvaluate(iusSTB1,ius_BR115200)
	#if (ius_V115200_STB1<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB1, ius_V115200_STB1)-ius_BR115200)<=ius_INACCURACY115200)
        #undef ius_INACCURACY115200
        #undef ius_v115200
        #undef ius_SetupTimeBase115200
        #define ius_INACCURACY115200 (ius_BaudEvaluate(iusSTB1, ius_V115200_STB1)-ius_BR115200)
        #define ius_v115200	((TypeOfTimer)ius_V115200_STB1)
        #define ius_SetupTimeBase115200 iusSETUP_STB1
      #endif
    #endif
  #endif //iusSTB1
  #ifdef iusSTB2
    #define ius_V115200_STB2	ius_TimerEvaluate(iusSTB2,ius_BR115200)
	#if (ius_V115200_STB2<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB2, ius_V115200_STB2)-ius_BR115200)<=ius_INACCURACY115200)
        #undef ius_INACCURACY115200
        #undef ius_v115200
        #undef ius_SetupTimeBase115200
        #define ius_INACCURACY115200 (ius_BaudEvaluate(iusSTB2, ius_V115200_STB2)-ius_BR115200)
        #define ius_v115200	((TypeOfTimer)ius_V115200_STB2)
        #define ius_SetupTimeBase115200 iusSETUP_STB2
      #endif
    #endif
  #endif //iusSTB2
  #ifdef iusSTB3
    #define ius_V115200_STB3	ius_TimerEvaluate(iusSTB3,ius_BR115200)
	#if (ius_V115200_STB3<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB3, ius_V115200_STB3)-ius_BR115200)<=ius_INACCURACY115200)
        #undef ius_INACCURACY115200
        #undef ius_v115200
        #undef ius_SetupTimeBase115200
        #define ius_INACCURACY115200 (ius_BaudEvaluate(iusSTB3, ius_V115200_STB3)-ius_BR115200)
        #define ius_v115200	((TypeOfTimer)ius_V115200_STB3)
        #define ius_SetupTimeBase115200 iusSETUP_STB3
      #endif
    #endif
  #endif //iusSTB3
  #ifdef iusSTB4
    #define ius_V115200_STB4	ius_TimerEvaluate(iusSTB4,ius_BR115200)
	#if (ius_V115200_STB4<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB4, ius_V115200_STB4)-ius_BR115200)<=ius_INACCURACY115200)
        #undef ius_INACCURACY115200
        #undef ius_v115200
        #undef ius_SetupTimeBase115200
        #define ius_INACCURACY115200 (ius_BaudEvaluate(iusSTB4, ius_V115200_STB4)-ius_BR115200)
        #define ius_v115200	((TypeOfTimer)ius_V115200_STB4)
        #define ius_SetupTimeBase115200 iusSETUP_STB4
      #endif
    #endif
  #endif //iusSTB4
  #ifdef iusSTB5
    #define ius_V115200_STB5	ius_TimerEvaluate(iusSTB5,ius_BR115200)
	#if (ius_V115200_STB5<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB5, ius_V115200_STB5)-ius_BR115200)<=ius_INACCURACY115200)
        #undef ius_INACCURACY115200
        #undef ius_v115200
        #undef ius_SetupTimeBase115200
        #define ius_INACCURACY115200 (ius_BaudEvaluate(iusSTB5, ius_V115200_STB5)-ius_BR115200)
        #define ius_v115200	((TypeOfTimer)ius_V115200_STB5)
        #define ius_SetupTimeBase115200 iusSETUP_STB5
      #endif
    #endif
  #endif //iusSTB5
  #ifdef iusSTB6
    #define ius_V115200_STB6	ius_TimerEvaluate(iusSTB6,ius_BR115200)
	#if (ius_V115200_STB6<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB6, ius_V115200_STB6)-ius_BR115200)<=ius_INACCURACY115200)
        #undef ius_INACCURACY115200
        #undef ius_v115200
        #undef ius_SetupTimeBase115200
        #define ius_INACCURACY115200 (ius_BaudEvaluate(iusSTB6, ius_V115200_STB6)-ius_BR115200)
        #define ius_v115200	((TypeOfTimer)ius_V115200_STB6)
        #define ius_SetupTimeBase115200 iusSETUP_STB6
     #endif
   #endif
  #endif //iusSTB6
  #ifdef iusSTB7
    #define ius_V115200_STB7	ius_TimerEvaluate(iusSTB7,ius_BR115200)
	#if (ius_V115200_STB7<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB7, ius_V115200_STB7)-ius_BR115200)<=ius_INACCURACY115200)
        #undef ius_INACCURACY115200
        #undef ius_v115200
        #undef ius_SetupTimeBase115200
        #define ius_INACCURACY115200 (ius_BaudEvaluate(iusSTB7, ius_V115200_STB7)-ius_BR115200)
        #define ius_v115200	((TypeOfTimer)ius_V115200_STB7)
        #define ius_SetupTimeBase115200 iusSETUP_STB7
      #endif
    #endif
  #endif //iusSTB7
  #ifdef iusSTB8
    #define ius_V115200_STB8	ius_TimerEvaluate(iusSTB8,ius_BR115200)
	#if (ius_V115200_STB7<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB8, ius_V115200_STB8)-ius_BR115200)<=ius_INACCURACY115200)
        #undef ius_INACCURACY115200
        #undef ius_v115200
        #undef ius_SetupTimeBase115200
        #define ius_INACCURACY115200 (ius_BaudEvaluate(iusSTB8, ius_V115200_STB8)-ius_BR115200)
        #define ius_v115200	((TypeOfTimer)ius_V115200_STB8)
        #define ius_SetupTimeBase115200 iusSETUP_STB8
      #endif
    #endif
  #endif //iusSTB8
  #ifdef iusSTB9
    #define ius_V115200_STB9	ius_TimerEvaluate(iusSTB9,ius_BR115200)
	#if (ius_V115200_STB9<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB9, ius_V115200_STB9)-ius_BR115200)<=ius_INACCURACY115200)
        #undef ius_INACCURACY115200
        #undef ius_v115200
        #undef ius_SetupTimeBase115200
        #define ius_INACCURACY115200 (ius_BaudEvaluate(iusSTB9, ius_V115200_STB9)-ius_BR115200)
        #define ius_v115200	((TypeOfTimer)ius_V115200_STB9)
        #define ius_SetupTimeBase115200 iusSETUP_STB9
      #endif
    #endif
  #endif //iusSTB9
#endif //ius_BR115200

//-----Round of 57600 Baud Rates -----------------------------------------------------------------------
#ifdef ius_BR57600
  #ifdef iusSTB0
    #define ius_V57600_STB0	ius_TimerEvaluate(iusSTB0,ius_BR57600)
	#if (ius_V57600_STB0<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB0, ius_V57600_STB0)-ius_BR57600)<=ius_INACCURACY57600)
        #undef ius_INACCURACY57600
        #undef ius_v57600
        #undef ius_SetupTimeBase57600
        #define ius_INACCURACY57600 (ius_BaudEvaluate(iusSTB0, ius_V57600_STB0)-ius_BR57600)
        #define ius_v57600	((TypeOfTimer)ius_V57600_STB0)
        #define ius_SetupTimeBase57600 iusSETUP_STB0
      #endif
	#endif
  #endif //iusSTB0
  #ifdef iusSTB1
    #define ius_V57600_STB1	ius_TimerEvaluate(iusSTB1,ius_BR57600)
	#if (ius_V57600_STB1<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB1, ius_V57600_STB1)-ius_BR57600)<=ius_INACCURACY57600)
        #undef ius_INACCURACY57600
        #undef ius_v57600
        #undef ius_SetupTimeBase57600
        #define ius_INACCURACY57600 (ius_BaudEvaluate(iusSTB1, ius_V57600_STB1)-ius_BR57600)
        #define ius_v57600	((TypeOfTimer)ius_V57600_STB1)
        #define ius_SetupTimeBase57600 iusSETUP_STB1
      #endif
    #endif
  #endif //iusSTB1
  #ifdef iusSTB2
    #define ius_V57600_STB2	ius_TimerEvaluate(iusSTB2,ius_BR57600)
	#if (ius_V57600_STB2<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB2, ius_V57600_STB2)-ius_BR57600)<=ius_INACCURACY57600)
        #undef ius_INACCURACY57600
        #undef ius_v57600
        #undef ius_SetupTimeBase57600
        #define ius_INACCURACY57600 (ius_BaudEvaluate(iusSTB2, ius_V57600_STB2)-ius_BR57600)
        #define ius_v57600	((TypeOfTimer)ius_V57600_STB2)
        #define ius_SetupTimeBase57600 iusSETUP_STB2
      #endif
    #endif
  #endif //iusSTB2
  #ifdef iusSTB3
    #define ius_V57600_STB3	ius_TimerEvaluate(iusSTB3,ius_BR57600)
	#if (ius_V57600_STB3<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB3, ius_V57600_STB3)-ius_BR57600)<=ius_INACCURACY57600)
        #undef ius_INACCURACY57600
        #undef ius_v57600
        #undef ius_SetupTimeBase57600
        #define ius_INACCURACY57600 (ius_BaudEvaluate(iusSTB3, ius_V57600_STB3)-ius_BR57600)
        #define ius_v57600	((TypeOfTimer)ius_V57600_STB3)
        #define ius_SetupTimeBase57600 iusSETUP_STB3
      #endif
    #endif
  #endif //iusSTB3
  #ifdef iusSTB4
    #define ius_V57600_STB4	ius_TimerEvaluate(iusSTB4,ius_BR57600)
	#if (ius_V57600_STB4<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB4, ius_V57600_STB4)-ius_BR57600)<=ius_INACCURACY57600)
        #undef ius_INACCURACY57600
        #undef ius_v57600
        #undef ius_SetupTimeBase57600
        #define ius_INACCURACY57600 (ius_BaudEvaluate(iusSTB4, ius_V57600_STB4)-ius_BR57600)
        #define ius_v57600	((TypeOfTimer)ius_V57600_STB4)
        #define ius_SetupTimeBase57600 iusSETUP_STB4
      #endif
    #endif
  #endif //iusSTB4
  #ifdef iusSTB5
    #define ius_V57600_STB5	ius_TimerEvaluate(iusSTB5,ius_BR57600)
	#if (ius_V57600_STB5<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB5, ius_V57600_STB5)-ius_BR57600)<=ius_INACCURACY57600)
        #undef ius_INACCURACY57600
        #undef ius_v57600
        #undef ius_SetupTimeBase57600
        #define ius_INACCURACY57600 (ius_BaudEvaluate(iusSTB5, ius_V57600_STB5)-ius_BR57600)
        #define ius_v57600	((TypeOfTimer)ius_V57600_STB5)
        #define ius_SetupTimeBase57600 iusSETUP_STB5
      #endif
    #endif
  #endif //iusSTB5
  #ifdef iusSTB6
    #define ius_V57600_STB6	ius_TimerEvaluate(iusSTB6,ius_BR57600)
	#if (ius_V57600_STB6<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB6, ius_V57600_STB6)-ius_BR57600)<=ius_INACCURACY57600)
        #undef ius_INACCURACY57600
        #undef ius_v57600
  	    #undef ius_SetupTimeBase57600
        #define ius_INACCURACY57600 (ius_BaudEvaluate(iusSTB6, ius_V57600_STB6)-ius_BR57600)
        #define ius_v57600	((TypeOfTimer)ius_V57600_STB6)
        #define ius_SetupTimeBase57600 iusSETUP_STB6
     #endif
   #endif
  #endif //iusSTB6
  #ifdef iusSTB7
    #define ius_V57600_STB7	ius_TimerEvaluate(iusSTB7,ius_BR57600)
	#if (ius_V57600_STB7<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB7, ius_V57600_STB7)-ius_BR57600)<=ius_INACCURACY57600)
        #undef ius_INACCURACY57600
        #undef ius_v57600
        #undef ius_SetupTimeBase57600
        #define ius_INACCURACY57600 (ius_BaudEvaluate(iusSTB7, ius_V57600_STB7)-ius_BR57600)
        #define ius_v57600	((TypeOfTimer)ius_V57600_STB7)
        #define ius_SetupTimeBase57600 iusSETUP_STB7
      #endif
    #endif
  #endif //iusSTB7
  #ifdef iusSTB8
    #define ius_V57600_STB8	ius_TimerEvaluate(iusSTB8,ius_BR57600)
	#if (ius_V57600_STB7<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB8, ius_V57600_STB8)-ius_BR57600)<=ius_INACCURACY57600)
        #undef ius_INACCURACY57600
        #undef ius_v57600
        #undef ius_SetupTimeBase57600
        #define ius_INACCURACY57600 (ius_BaudEvaluate(iusSTB8, ius_V57600_STB8)-ius_BR57600)
        #define ius_v57600	((TypeOfTimer)ius_V57600_STB8)
        #define ius_SetupTimeBase57600 iusSETUP_STB8
      #endif
    #endif
  #endif //iusSTB8
  #ifdef iusSTB9
    #define ius_V57600_STB9	ius_TimerEvaluate(iusSTB9,ius_BR57600)
	#if (ius_V57600_STB9<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB9, ius_V57600_STB9)-ius_BR57600)<=ius_INACCURACY57600)
        #undef ius_INACCURACY57600
        #undef ius_v57600
        #undef ius_SetupTimeBase57600
        #define ius_INACCURACY57600 (ius_BaudEvaluate(iusSTB9, ius_V57600_STB9)-ius_BR57600)
        #define ius_v57600	((TypeOfTimer)ius_V57600_STB9)
        #define ius_SetupTimeBase57600 iusSETUP_STB9
      #endif
    #endif
  #endif //iusSTB9
#endif //ius_BR57600

//-----Round of 38400 Baud Rates -----------------------------------------------------------------------
#ifdef ius_BR38400
  #ifdef iusSTB0
    #define ius_V38400_STB0	ius_TimerEvaluate(iusSTB0,ius_BR38400)
	#if (ius_V38400_STB0<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB0, ius_V38400_STB0)-ius_BR38400)<=ius_INACCURACY38400)
        #undef ius_INACCURACY38400
        #undef ius_v38400
        #undef ius_SetupTimeBase38400
        #define ius_INACCURACY38400 (ius_BaudEvaluate(iusSTB0, ius_V38400_STB0)-ius_BR38400)
        #define ius_v38400	((TypeOfTimer)ius_V38400_STB0)
        #define ius_SetupTimeBase38400 iusSETUP_STB0
      #endif
	#endif
  #endif //iusSTB0
  #ifdef iusSTB1
    #define ius_V38400_STB1	ius_TimerEvaluate(iusSTB1,ius_BR38400)
	#if (ius_V38400_STB1<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB1, ius_V38400_STB1)-ius_BR38400)<=ius_INACCURACY38400)
        #undef ius_INACCURACY38400
        #undef ius_v38400
        #undef ius_SetupTimeBase38400
        #define ius_INACCURACY38400 (ius_BaudEvaluate(iusSTB1, ius_V38400_STB1)-ius_BR38400)
        #define ius_v38400	((TypeOfTimer)ius_V38400_STB1)
        #define ius_SetupTimeBase38400 iusSETUP_STB1
      #endif
    #endif
  #endif //iusSTB1
  #ifdef iusSTB2
    #define ius_V38400_STB2	ius_TimerEvaluate(iusSTB2,ius_BR38400)
	#if (ius_V38400_STB2<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB2, ius_V38400_STB2)-ius_BR38400)<=ius_INACCURACY38400)
        #undef ius_INACCURACY38400
        #undef ius_v38400
        #undef ius_SetupTimeBase38400
        #define ius_INACCURACY38400 (ius_BaudEvaluate(iusSTB2, ius_V38400_STB2)-ius_BR38400)
        #define ius_v38400	((TypeOfTimer)ius_V38400_STB2)
        #define ius_SetupTimeBase38400 iusSETUP_STB2
      #endif
    #endif
  #endif //iusSTB2
  #ifdef iusSTB3
    #define ius_V38400_STB3	ius_TimerEvaluate(iusSTB3,ius_BR38400)
	#if (ius_V38400_STB3<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB3, ius_V38400_STB3)-ius_BR38400)<=ius_INACCURACY38400)
        #undef ius_INACCURACY38400
        #undef ius_v38400
        #undef ius_SetupTimeBase38400
        #define ius_INACCURACY38400 (ius_BaudEvaluate(iusSTB3, ius_V38400_STB3)-ius_BR38400)
        #define ius_v38400	((TypeOfTimer)ius_V38400_STB3)
        #define ius_SetupTimeBase38400 iusSETUP_STB3
      #endif
    #endif
  #endif //iusSTB3
  #ifdef iusSTB4
    #define ius_V38400_STB4	ius_TimerEvaluate(iusSTB4,ius_BR38400)
	#if (ius_V38400_STB4<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB4, ius_V38400_STB4)-ius_BR38400)<=ius_INACCURACY38400)
        #undef ius_INACCURACY38400
        #undef ius_v38400
        #undef ius_SetupTimeBase38400
        #define ius_INACCURACY38400 (ius_BaudEvaluate(iusSTB4, ius_V38400_STB4)-ius_BR38400)
        #define ius_v38400	((TypeOfTimer)ius_V38400_STB4)
        #define ius_SetupTimeBase38400 iusSETUP_STB4
      #endif
    #endif
  #endif //iusSTB4
  #ifdef iusSTB5
    #define ius_V38400_STB5	ius_TimerEvaluate(iusSTB5,ius_BR38400)
	#if (ius_V38400_STB5<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB5, ius_V38400_STB5)-ius_BR38400)<=ius_INACCURACY38400)
        #undef ius_INACCURACY38400
        #undef ius_v38400
        #undef ius_SetupTimeBase38400
        #define ius_INACCURACY38400 (ius_BaudEvaluate(iusSTB5, ius_V38400_STB5)-ius_BR38400)
        #define ius_v38400	((TypeOfTimer)ius_V38400_STB5)
        #define ius_SetupTimeBase38400 iusSETUP_STB5
      #endif
    #endif
  #endif //iusSTB5
  #ifdef iusSTB6
    #define ius_V38400_STB6	ius_TimerEvaluate(iusSTB6,ius_BR38400)
	#if (ius_V38400_STB6<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB6, ius_V38400_STB6)-ius_BR38400)<=ius_INACCURACY38400)
        #undef ius_INACCURACY38400
        #undef ius_v38400
  	    #undef ius_SetupTimeBase38400
        #define ius_INACCURACY38400 (ius_BaudEvaluate(iusSTB6, ius_V38400_STB6)-ius_BR38400)
        #define ius_v38400	((TypeOfTimer)ius_V38400_STB6)
        #define ius_SetupTimeBase38400 iusSETUP_STB6
     #endif
   #endif
  #endif //iusSTB6
  #ifdef iusSTB7
    #define ius_V38400_STB7	ius_TimerEvaluate(iusSTB7,ius_BR38400)
	#if (ius_V38400_STB7<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB7, ius_V38400_STB7)-ius_BR38400)<=ius_INACCURACY38400)
        #undef ius_INACCURACY38400
        #undef ius_v38400
        #undef ius_SetupTimeBase38400
        #define ius_INACCURACY38400 (ius_BaudEvaluate(iusSTB7, ius_V38400_STB7)-ius_BR38400)
        #define ius_v38400	((TypeOfTimer)ius_V38400_STB7)
        #define ius_SetupTimeBase38400 iusSETUP_STB7
      #endif
    #endif
  #endif //iusSTB7
  #ifdef iusSTB8
    #define ius_V38400_STB8	ius_TimerEvaluate(iusSTB8,ius_BR38400)
	#if (ius_V38400_STB7<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB8, ius_V38400_STB8)-ius_BR38400)<=ius_INACCURACY38400)
        #undef ius_INACCURACY38400
        #undef ius_v38400
        #undef ius_SetupTimeBase38400
        #define ius_INACCURACY38400 (ius_BaudEvaluate(iusSTB8, ius_V38400_STB8)-ius_BR38400)
        #define ius_v38400	((TypeOfTimer)ius_V38400_STB8)
        #define ius_SetupTimeBase38400 iusSETUP_STB8
      #endif
    #endif
  #endif //iusSTB8
  #ifdef iusSTB9
    #define ius_V38400_STB9	ius_TimerEvaluate(iusSTB9,ius_BR38400)
	#if (ius_V38400_STB9<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB9, ius_V38400_STB9)-ius_BR38400)<=ius_INACCURACY38400)
        #undef ius_INACCURACY38400
        #undef ius_v38400
        #undef ius_SetupTimeBase38400
        #define ius_INACCURACY38400 (ius_BaudEvaluate(iusSTB9, ius_V38400_STB9)-ius_BR38400)
        #define ius_v38400	((TypeOfTimer)ius_V38400_STB9)
        #define ius_SetupTimeBase38400 iusSETUP_STB9
      #endif
    #endif
  #endif //iusSTB9
#endif //ius_BR38400

//-----Round of 19200 Baud Rates -----------------------------------------------------------------------
#ifdef ius_BR19200
  #ifdef iusSTB0
    #define ius_V19200_STB0	ius_TimerEvaluate(iusSTB0,ius_BR19200)
	#if (ius_V19200_STB0<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB0, ius_V19200_STB0)-ius_BR19200)<=ius_INACCURACY19200)
        #undef ius_INACCURACY19200
        #undef ius_v19200
        #undef ius_SetupTimeBase19200
        #define ius_INACCURACY19200 (ius_BaudEvaluate(iusSTB0, ius_V19200_STB0)-ius_BR19200)
        #define ius_v19200	((TypeOfTimer)ius_V19200_STB0)
        #define ius_SetupTimeBase19200 iusSETUP_STB0
      #endif
	#endif
  #endif //iusSTB0
  #ifdef iusSTB1
    #define ius_V19200_STB1	ius_TimerEvaluate(iusSTB1,ius_BR19200)
	#if (ius_V19200_STB1<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB1, ius_V19200_STB1)-ius_BR19200)<=ius_INACCURACY19200)
        #undef ius_INACCURACY19200
        #undef ius_v19200
        #undef ius_SetupTimeBase19200
        #define ius_INACCURACY19200 (ius_BaudEvaluate(iusSTB1, ius_V19200_STB1)-ius_BR19200)
        #define ius_v19200	((TypeOfTimer)ius_V19200_STB1)
        #define ius_SetupTimeBase19200 iusSETUP_STB1
      #endif
    #endif
  #endif //iusSTB1
  #ifdef iusSTB2
    #define ius_V19200_STB2	ius_TimerEvaluate(iusSTB2,ius_BR19200)
	#if (ius_V19200_STB2<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB2, ius_V19200_STB2)-ius_BR19200)<=ius_INACCURACY19200)
        #undef ius_INACCURACY19200
        #undef ius_v19200
        #undef ius_SetupTimeBase19200
        #define ius_INACCURACY19200 (ius_BaudEvaluate(iusSTB2, ius_V19200_STB2)-ius_BR19200)
        #define ius_v19200	((TypeOfTimer)ius_V19200_STB2)
        #define ius_SetupTimeBase19200 iusSETUP_STB2
      #endif
    #endif
  #endif //iusSTB2
  #ifdef iusSTB3
    #define ius_V19200_STB3	ius_TimerEvaluate(iusSTB3,ius_BR19200)
	#if (ius_V19200_STB3<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB3, ius_V19200_STB3)-ius_BR19200)<=ius_INACCURACY19200)
        #undef ius_INACCURACY19200
        #undef ius_v19200
        #undef ius_SetupTimeBase19200
        #define ius_INACCURACY19200 (ius_BaudEvaluate(iusSTB3, ius_V19200_STB3)-ius_BR19200)
        #define ius_v19200	((TypeOfTimer)ius_V19200_STB3)
        #define ius_SetupTimeBase19200 iusSETUP_STB3
      #endif
    #endif
  #endif //iusSTB3
  #ifdef iusSTB4
    #define ius_V19200_STB4	ius_TimerEvaluate(iusSTB4,ius_BR19200)
	#if (ius_V19200_STB4<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB4, ius_V19200_STB4)-ius_BR19200)<=ius_INACCURACY19200)
        #undef ius_INACCURACY19200
        #undef ius_v19200
        #undef ius_SetupTimeBase19200
        #define ius_INACCURACY19200 (ius_BaudEvaluate(iusSTB4, ius_V19200_STB4)-ius_BR19200)
        #define ius_v19200	((TypeOfTimer)ius_V19200_STB4)
        #define ius_SetupTimeBase19200 iusSETUP_STB4
      #endif
    #endif
  #endif //iusSTB4
  #ifdef iusSTB5
    #define ius_V19200_STB5	ius_TimerEvaluate(iusSTB5,ius_BR19200)
	#if (ius_V19200_STB5<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB5, ius_V19200_STB5)-ius_BR19200)<=ius_INACCURACY19200)
        #undef ius_INACCURACY19200
        #undef ius_v19200
        #undef ius_SetupTimeBase19200
        #define ius_INACCURACY19200 (ius_BaudEvaluate(iusSTB5, ius_V19200_STB5)-ius_BR19200)
        #define ius_v19200	((TypeOfTimer)ius_V19200_STB5)
        #define ius_SetupTimeBase19200 iusSETUP_STB5
      #endif
    #endif
  #endif //iusSTB5
  #ifdef iusSTB6
    #define ius_V19200_STB6	ius_TimerEvaluate(iusSTB6,ius_BR19200)
	#if (ius_V19200_STB6<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB6, ius_V19200_STB6)-ius_BR19200)<=ius_INACCURACY19200)
        #undef ius_INACCURACY19200
        #undef ius_v19200
  	    #undef ius_SetupTimeBase19200
        #define ius_INACCURACY19200 (ius_BaudEvaluate(iusSTB6, ius_V19200_STB6)-ius_BR19200)
        #define ius_v19200	((TypeOfTimer)ius_V19200_STB6)
        #define ius_SetupTimeBase19200 iusSETUP_STB6
     #endif
   #endif
  #endif //iusSTB6
  #ifdef iusSTB7
    #define ius_V19200_STB7	ius_TimerEvaluate(iusSTB7,ius_BR19200)
	#if (ius_V19200_STB7<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB7, ius_V19200_STB7)-ius_BR19200)<=ius_INACCURACY19200)
        #undef ius_INACCURACY19200
        #undef ius_v19200
        #undef ius_SetupTimeBase19200
        #define ius_INACCURACY19200 (ius_BaudEvaluate(iusSTB7, ius_V19200_STB7)-ius_BR19200)
        #define ius_v19200	((TypeOfTimer)ius_V19200_STB7)
        #define ius_SetupTimeBase19200 iusSETUP_STB7
      #endif
    #endif
  #endif //iusSTB7
  #ifdef iusSTB8
    #define ius_V19200_STB8	ius_TimerEvaluate(iusSTB8,ius_BR19200)
	#if (ius_V19200_STB7<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB8, ius_V19200_STB8)-ius_BR19200)<=ius_INACCURACY19200)
        #undef ius_INACCURACY19200
        #undef ius_v19200
        #undef ius_SetupTimeBase19200
        #define ius_INACCURACY19200 (ius_BaudEvaluate(iusSTB8, ius_V19200_STB8)-ius_BR19200)
        #define ius_v19200	((TypeOfTimer)ius_V19200_STB8)
        #define ius_SetupTimeBase19200 iusSETUP_STB8
      #endif
    #endif
  #endif //iusSTB8
  #ifdef iusSTB9
    #define ius_V19200_STB9	ius_TimerEvaluate(iusSTB9,ius_BR19200)
	#if (ius_V19200_STB9<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB9, ius_V19200_STB9)-ius_BR19200)<=ius_INACCURACY19200)
        #undef ius_INACCURACY19200
        #undef ius_v19200
        #undef ius_SetupTimeBase19200
        #define ius_INACCURACY19200 (ius_BaudEvaluate(iusSTB9, ius_V19200_STB9)-ius_BR19200)
        #define ius_v19200	((TypeOfTimer)ius_V19200_STB9)
        #define ius_SetupTimeBase19200 iusSETUP_STB9
      #endif
    #endif
  #endif //iusSTB9
#endif //ius_BR19200

//-----Round of 9600 Baud Rates -----------------------------------------------------------------------
#ifdef ius_BR9600
  #ifdef iusSTB0
    #define ius_V9600_STB0	ius_TimerEvaluate(iusSTB0,ius_BR9600)
	#if (ius_V9600_STB0<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB0, ius_V9600_STB0)-ius_BR9600)<=ius_INACCURACY9600)
        #undef ius_INACCURACY9600
        #undef ius_v9600
        #undef ius_SetupTimeBase9600
        #define ius_INACCURACY9600 (ius_BaudEvaluate(iusSTB0, ius_V9600_STB0)-ius_BR9600)
        #define ius_v9600	((TypeOfTimer)ius_V9600_STB0)
        #define ius_SetupTimeBase9600 iusSETUP_STB0
      #endif
	#endif
  #endif //iusSTB0
  #ifdef iusSTB1
    #define ius_V9600_STB1	ius_TimerEvaluate(iusSTB1,ius_BR9600)
	#if (ius_V9600_STB1<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB1, ius_V9600_STB1)-ius_BR9600)<=ius_INACCURACY9600)
        #undef ius_INACCURACY9600
        #undef ius_v9600
        #undef ius_SetupTimeBase9600
        #define ius_INACCURACY9600 (ius_BaudEvaluate(iusSTB1, ius_V9600_STB1)-ius_BR9600)
        #define ius_v9600	((TypeOfTimer)ius_V9600_STB1)
        #define ius_SetupTimeBase9600 iusSETUP_STB1
      #endif
    #endif
  #endif //iusSTB1
  #ifdef iusSTB2
    #define ius_V9600_STB2	ius_TimerEvaluate(iusSTB2,ius_BR9600)
	#if (ius_V9600_STB2<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB2, ius_V9600_STB2)-ius_BR9600)<=ius_INACCURACY9600)
        #undef ius_INACCURACY9600
        #undef ius_v9600
        #undef ius_SetupTimeBase9600
        #define ius_INACCURACY9600 (ius_BaudEvaluate(iusSTB2, ius_V9600_STB2)-ius_BR9600)
        #define ius_v9600	((TypeOfTimer)ius_V9600_STB2)
        #define ius_SetupTimeBase9600 iusSETUP_STB2
      #endif
    #endif
  #endif //iusSTB2
  #ifdef iusSTB3
    #define ius_V9600_STB3	ius_TimerEvaluate(iusSTB3,ius_BR9600)
	#if (ius_V9600_STB3<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB3, ius_V9600_STB3)-ius_BR9600)<=ius_INACCURACY9600)
        #undef ius_INACCURACY9600
        #undef ius_v9600
        #undef ius_SetupTimeBase9600
        #define ius_INACCURACY9600 (ius_BaudEvaluate(iusSTB3, ius_V9600_STB3)-ius_BR9600)
        #define ius_v9600	((TypeOfTimer)ius_V9600_STB3)
        #define ius_SetupTimeBase9600 iusSETUP_STB3
      #endif
    #endif
  #endif //iusSTB3
  #ifdef iusSTB4
    #define ius_V9600_STB4	ius_TimerEvaluate(iusSTB4,ius_BR9600)
	#if (ius_V9600_STB4<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB4, ius_V9600_STB4)-ius_BR9600)<=ius_INACCURACY9600)
        #undef ius_INACCURACY9600
        #undef ius_v9600
        #undef ius_SetupTimeBase9600
        #define ius_INACCURACY9600 (ius_BaudEvaluate(iusSTB4, ius_V9600_STB4)-ius_BR9600)
        #define ius_v9600	((TypeOfTimer)ius_V9600_STB4)
        #define ius_SetupTimeBase9600 iusSETUP_STB4
      #endif
    #endif
  #endif //iusSTB4
  #ifdef iusSTB5
    #define ius_V9600_STB5	ius_TimerEvaluate(iusSTB5,ius_BR9600)
	#if (ius_V9600_STB5<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB5, ius_V9600_STB5)-ius_BR9600)<=ius_INACCURACY9600)
        #undef ius_INACCURACY9600
        #undef ius_v9600
        #undef ius_SetupTimeBase9600
        #define ius_INACCURACY9600 (ius_BaudEvaluate(iusSTB5, ius_V9600_STB5)-ius_BR9600)
        #define ius_v9600	((TypeOfTimer)ius_V9600_STB5)
        #define ius_SetupTimeBase9600 iusSETUP_STB5
      #endif
    #endif
  #endif //iusSTB5
  #ifdef iusSTB6
    #define ius_V9600_STB6	ius_TimerEvaluate(iusSTB6,ius_BR9600)
	#if (ius_V9600_STB6<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB6, ius_V9600_STB6)-ius_BR9600)<=ius_INACCURACY9600)
        #undef ius_INACCURACY9600
        #undef ius_v9600
  	    #undef ius_SetupTimeBase9600
        #define ius_INACCURACY9600 (ius_BaudEvaluate(iusSTB6, ius_V9600_STB6)-ius_BR9600)
        #define ius_v9600	((TypeOfTimer)ius_V9600_STB6)
        #define ius_SetupTimeBase9600 iusSETUP_STB6
     #endif
   #endif
  #endif //iusSTB6
  #ifdef iusSTB7
    #define ius_V9600_STB7	ius_TimerEvaluate(iusSTB7,ius_BR9600)
	#if (ius_V9600_STB7<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB7, ius_V9600_STB7)-ius_BR9600)<=ius_INACCURACY9600)
        #undef ius_INACCURACY9600
        #undef ius_v9600
        #undef ius_SetupTimeBase9600
        #define ius_INACCURACY9600 (ius_BaudEvaluate(iusSTB7, ius_V9600_STB7)-ius_BR9600)
        #define ius_v9600	((TypeOfTimer)ius_V9600_STB7)
        #define ius_SetupTimeBase9600 iusSETUP_STB7
      #endif
    #endif
  #endif //iusSTB7
  #ifdef iusSTB8
    #define ius_V9600_STB8	ius_TimerEvaluate(iusSTB8,ius_BR9600)
	#if (ius_V9600_STB7<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB8, ius_V9600_STB8)-ius_BR9600)<=ius_INACCURACY9600)
        #undef ius_INACCURACY9600
        #undef ius_v9600
        #undef ius_SetupTimeBase9600
        #define ius_INACCURACY9600 (ius_BaudEvaluate(iusSTB8, ius_V9600_STB8)-ius_BR9600)
        #define ius_v9600	((TypeOfTimer)ius_V9600_STB8)
        #define ius_SetupTimeBase9600 iusSETUP_STB8
      #endif
    #endif
  #endif //iusSTB8
  #ifdef iusSTB9
    #define ius_V9600_STB9	ius_TimerEvaluate(iusSTB9,ius_BR9600)
	#if (ius_V9600_STB9<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB9, ius_V9600_STB9)-ius_BR9600)<=ius_INACCURACY9600)
        #undef ius_INACCURACY9600
        #undef ius_v9600
        #undef ius_SetupTimeBase9600
        #define ius_INACCURACY9600 (ius_BaudEvaluate(iusSTB9, ius_V9600_STB9)-ius_BR9600)
        #define ius_v9600	((TypeOfTimer)ius_V9600_STB9)
        #define ius_SetupTimeBase9600 iusSETUP_STB9
      #endif
    #endif
  #endif //iusSTB9
#endif //ius_BR9600

//-----Round of 4800 Baud Rates -----------------------------------------------------------------------
#ifdef ius_BR4800
  #ifdef iusSTB0
    #define ius_V4800_STB0	ius_TimerEvaluate(iusSTB0,ius_BR4800)
	#if (ius_V4800_STB0<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB0, ius_V4800_STB0)-ius_BR4800)<=ius_INACCURACY4800)
        #undef ius_INACCURACY4800
        #undef ius_v4800
        #undef ius_SetupTimeBase4800
        #define ius_INACCURACY4800 (ius_BaudEvaluate(iusSTB0, ius_V4800_STB0)-ius_BR4800)
        #define ius_v4800	((TypeOfTimer)ius_V4800_STB0)
        #define ius_SetupTimeBase4800 iusSETUP_STB0
      #endif
	#endif
  #endif //iusSTB0
  #ifdef iusSTB1
    #define ius_V4800_STB1	ius_TimerEvaluate(iusSTB1,ius_BR4800)
	#if (ius_V4800_STB1<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB1, ius_V4800_STB1)-ius_BR4800)<=ius_INACCURACY4800)
        #undef ius_INACCURACY4800
        #undef ius_v4800
        #undef ius_SetupTimeBase4800
        #define ius_INACCURACY4800 (ius_BaudEvaluate(iusSTB1, ius_V4800_STB1)-ius_BR4800)
        #define ius_v4800	((TypeOfTimer)ius_V4800_STB1)
        #define ius_SetupTimeBase4800 iusSETUP_STB1
      #endif
    #endif
  #endif //iusSTB1
  #ifdef iusSTB2
    #define ius_V4800_STB2	ius_TimerEvaluate(iusSTB2,ius_BR4800)
	#if (ius_V4800_STB2<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB2, ius_V4800_STB2)-ius_BR4800)<=ius_INACCURACY4800)
        #undef ius_INACCURACY4800
        #undef ius_v4800
        #undef ius_SetupTimeBase4800
        #define ius_INACCURACY4800 (ius_BaudEvaluate(iusSTB2, ius_V4800_STB2)-ius_BR4800)
        #define ius_v4800	((TypeOfTimer)ius_V4800_STB2)
        #define ius_SetupTimeBase4800 iusSETUP_STB2
      #endif
    #endif
  #endif //iusSTB2
  #ifdef iusSTB3
    #define ius_V4800_STB3	ius_TimerEvaluate(iusSTB3,ius_BR4800)
	#if (ius_V4800_STB3<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB3, ius_V4800_STB3)-ius_BR4800)<=ius_INACCURACY4800)
        #undef ius_INACCURACY4800
        #undef ius_v4800
        #undef ius_SetupTimeBase4800
        #define ius_INACCURACY4800 (ius_BaudEvaluate(iusSTB3, ius_V4800_STB3)-ius_BR4800)
        #define ius_v4800	((TypeOfTimer)ius_V4800_STB3)
        #define ius_SetupTimeBase4800 iusSETUP_STB3
      #endif
    #endif
  #endif //iusSTB3
  #ifdef iusSTB4
    #define ius_V4800_STB4	ius_TimerEvaluate(iusSTB4,ius_BR4800)
	#if (ius_V4800_STB4<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB4, ius_V4800_STB4)-ius_BR4800)<=ius_INACCURACY4800)
        #undef ius_INACCURACY4800
        #undef ius_v4800
        #undef ius_SetupTimeBase4800
        #define ius_INACCURACY4800 (ius_BaudEvaluate(iusSTB4, ius_V4800_STB4)-ius_BR4800)
        #define ius_v4800	((TypeOfTimer)ius_V4800_STB4)
        #define ius_SetupTimeBase4800 iusSETUP_STB4
      #endif
    #endif
  #endif //iusSTB4
  #ifdef iusSTB5
    #define ius_V4800_STB5	ius_TimerEvaluate(iusSTB5,ius_BR4800)
	#if (ius_V4800_STB5<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB5, ius_V4800_STB5)-ius_BR4800)<=ius_INACCURACY4800)
        #undef ius_INACCURACY4800
        #undef ius_v4800
        #undef ius_SetupTimeBase4800
        #define ius_INACCURACY4800 (ius_BaudEvaluate(iusSTB5, ius_V4800_STB5)-ius_BR4800)
        #define ius_v4800	((TypeOfTimer)ius_V4800_STB5)
        #define ius_SetupTimeBase4800 iusSETUP_STB5
      #endif
    #endif
  #endif //iusSTB5
  #ifdef iusSTB6
    #define ius_V4800_STB6	ius_TimerEvaluate(iusSTB6,ius_BR4800)
	#if (ius_V4800_STB6<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB6, ius_V4800_STB6)-ius_BR4800)<=ius_INACCURACY4800)
        #undef ius_INACCURACY4800
        #undef ius_v4800
  	    #undef ius_SetupTimeBase4800
        #define ius_INACCURACY4800 (ius_BaudEvaluate(iusSTB6, ius_V4800_STB6)-ius_BR4800)
        #define ius_v4800	((TypeOfTimer)ius_V4800_STB6)
        #define ius_SetupTimeBase4800 iusSETUP_STB6
     #endif
   #endif
  #endif //iusSTB6
  #ifdef iusSTB7
    #define ius_V4800_STB7	ius_TimerEvaluate(iusSTB7,ius_BR4800)
	#if (ius_V4800_STB7<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB7, ius_V4800_STB7)-ius_BR4800)<=ius_INACCURACY4800)
        #undef ius_INACCURACY4800
        #undef ius_v4800
        #undef ius_SetupTimeBase4800
        #define ius_INACCURACY4800 (ius_BaudEvaluate(iusSTB7, ius_V4800_STB7)-ius_BR4800)
        #define ius_v4800	((TypeOfTimer)ius_V4800_STB7)
        #define ius_SetupTimeBase4800 iusSETUP_STB7
      #endif
    #endif
  #endif //iusSTB7
  #ifdef iusSTB8
    #define ius_V4800_STB8	ius_TimerEvaluate(iusSTB8,ius_BR4800)
	#if (ius_V4800_STB7<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB8, ius_V4800_STB8)-ius_BR4800)<=ius_INACCURACY4800)
        #undef ius_INACCURACY4800
        #undef ius_v4800
        #undef ius_SetupTimeBase4800
        #define ius_INACCURACY4800 (ius_BaudEvaluate(iusSTB8, ius_V4800_STB8)-ius_BR4800)
        #define ius_v4800	((TypeOfTimer)ius_V4800_STB8)
        #define ius_SetupTimeBase4800 iusSETUP_STB8
      #endif
    #endif
  #endif //iusSTB8
  #ifdef iusSTB9
    #define ius_V4800_STB9	ius_TimerEvaluate(iusSTB9,ius_BR4800)
	#if (ius_V4800_STB9<MAX_TIMER_VAL)
      #if ((ius_BaudEvaluate(iusSTB9, ius_V4800_STB9)-ius_BR4800)<=ius_INACCURACY4800)
        #undef ius_INACCURACY4800
        #undef ius_v4800
        #undef ius_SetupTimeBase4800
        #define ius_INACCURACY4800 (ius_BaudEvaluate(iusSTB9, ius_V4800_STB9)-ius_BR4800)
        #define ius_v4800	((TypeOfTimer)ius_V4800_STB9)
        #define ius_SetupTimeBase4800 iusSETUP_STB9
      #endif
    #endif
  #endif //iusSTB9
#endif //ius_BR4800


//====================================================================

//-----Error detect for serial configuration  -----------------------------------------------------------------------
#ifdef ius_BR230400 
  #if ius_INACCURACY230400>ius_AVAILABLE_tolerancy
    >>>Error:	//No appropriate configuration for 230400 baud rates
				//To avoid this error:
    			//Comment definition of "ius_BR230400"  or adjust "ius_SYSTEM_CLOCK" value
				//in the IUS51option.h 
  #endif
#endif 
#ifdef ius_BR115200
  #if ius_INACCURACY115200>ius_AVAILABLE_tolerancy
    >>>Error:	//No appropriate configuration for 115200 baud rates
				//To avoid this error:
    			//Comment definition of "ius_BR115200"  or adjust "ius_SYSTEM_CLOCK"
				//in the IUS51option.h 
  #endif
#endif
#ifdef ius_BR57600
  #if ius_INACCURACY57600>ius_AVAILABLE_tolerancy
    >>>Error:	//57600 baud rates setting had a bed precision
				//To avoid this error:
    			//Comment definition of "ius_BR57600"  or adjust "ius_SYSTEM_CLOCK"
				//in the IUS51option.h 
  #endif
#endif
#ifdef ius_BR38400
  #if ius_INACCURACY38400>ius_AVAILABLE_tolerancy
    >>>Error:	//No appropriate configuration for 57600 baud rates
				//To avoid this error:
    			//Comment definition of "ius_BR38400"  or adjust "ius_SYSTEM_CLOCK"
				//in the IUS51option.h 
  #endif
#endif
#ifdef ius_BR19200
  #if ius_INACCURACY19200>ius_AVAILABLE_tolerancy
    >>>Error:	//No appropriate configuration for 19200 baud rates
				//To avoid this error:
    			//Comment definition of "ius_BR19200"  or adjust "ius_SYSTEM_CLOCK"
				//in the IUS51option.h 
  #endif
#endif
#ifdef ius_BR9600
  #if ius_INACCURACY9600>ius_AVAILABLE_tolerancy
    >>>Error:	//No appropriate configuration for 9600 baud rates
				//To avoid this error:
				//Comment definition of "ius_BR9600"  or adjust "ius_SYSTEM_CLOCK"
				//in the IUS51option.h 
  #endif
#endif
#ifdef ius_BR4800
  #if ius_INACCURACY4800>ius_AVAILABLE_tolerancy
    >>>Error:	//No appropriate configuration for 4800 baud rates
				//BR4800 is the based baud rates. It must be defined.
  #endif
#endif
//====================================================================

//====================================================================
//Bit definition of IE
//====================================================================
#define ius_bitlocEA	(BYTE)7
#define ius_bitEA	((BYTE)1<<ius_bitlocEA)
#define ius_bitlocET2	(BYTE)5
#define ius_bitET2	((BYTE)1<<ius_bitlocET2)
#define ius_bitlocES	(BYTE)4
#define ius_bitES	((BYTE)1<<ius_bitlocES)
#define ius_bitlocET1	(BYTE)3
#define ius_bitET1	((BYTE)1<<ius_bitlocET1)
#define ius_bitlocEX1	(BYTE)2
#define ius_bitEX1	((BYTE)1<<ius_bitlocEX1)
#define ius_bitlocET0	(BYTE)1
#define ius_bitET0	((BYTE)1<<ius_bitlocET0)
#define ius_bitlocEX0	(BYTE)0
#define ius_bitEX0	((BYTE)1<<ius_bitlocEX0)

//====================================================================
//Bit definition of SCON
//====================================================================
#define ius_bitlocSM0	(BYTE)7
#define ius_bitSM0	((BYTE)1<<ius_bitlocSM0)
#define ius_bitlocSM1	(BYTE)6
#define ius_bitSM1	((BYTE)1<<ius_bitlocSM1)
#define ius_bitlocSM2	(BYTE)5
#define ius_bitSM2	((BYTE)1<<ius_bitlocSM2)
#define ius_bitlocREN	(BYTE)4
#define ius_bitREN	((BYTE)1<<ius_bitlocREN)
#define ius_bitlocTB8	(BYTE)3
#define ius_bitTB8	((BYTE)1<<ius_bitlocTB8)
#define ius_bitlocRB8	(BYTE)2
#define ius_bitRB8	((BYTE)1<<ius_bitlocRB8)
#define ius_bitlocTI	(BYTE)1
#define ius_bitTI	((BYTE)1<<ius_bitlocTI)
#define ius_bitlocRI	(BYTE)0
#define ius_bitRI	((BYTE)1<<ius_bitlocRI)
//====================================================================
//Bit definition of T2CON
//====================================================================
#define ius_bitlocTF2		(BYTE)7
#define ius_bitTF2		((BYTE)1<<ius_bitlocTF2)
#define ius_bitlocEXF2		(BYTE)6
#define ius_bitEXF2		((BYTE)1<<ius_bitlocEXF2)
#define ius_bitlocRCLK		(BYTE)5
#define ius_bitRCLK		((BYTE)1<<ius_bitlocRCLK)
#define ius_bitlocTCLK		(BYTE)4
#define ius_bitTCLK		((BYTE)1<<ius_bitlocTCLK)
#define ius_bitlocEXEN2		(BYTE)3
#define ius_bitEXEN2	((BYTE)1<<ius_bitlocEXEN2)
#define ius_bitlocTR2		(BYTE)2
#define ius_bitTR2		((BYTE)1<<ius_bitlocTR2)
#define ius_bitlocC_T2		(BYTE)1
#define ius_bitC_T2		((BYTE)1<<ius_bitlocC_T2)
#define ius_bitlocCP_RL2 		(BYTE)0
#define ius_bitCP_RL2	((BYTE)1<<ius_bitlocCP_RL2)
//====================================================================


//====================================================================
//Definitions of Query Baud rate
//====================================================================
#define ius_Query4800	(BYTE)0x10
#define ius_Query9600	(BYTE)0x11
#define ius_Query19200	(BYTE)0x12
#define ius_Query38400	(BYTE)0x13
#define ius_Query57600	(BYTE)0x14
#define ius_Query115200	(BYTE)0x15
#define ius_Query230400	(BYTE)0x16
//====================================================================

